/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Fre Sep 15 22:39:25 CEST 2000
    copyright            : (C) 2000 by Erik Buchmann
    email                : owner@ErikBuchmann.de


todo:
	das Warten auf das Ende des Sendevorganges durch schlieen und ffnen
	der Schnittstelle ist schwer unsauber - mir ist aber keine ordentliche
	Lsung eingefallen
***************************************************************************/

#include <main.h>

int main(int argc, char *argv[])
{
	// Meldung ausgeben
	puts("\nControl program for the serial AT89Cx051-programmer");
	puts(" Unix-Version, Erik Buchmann, Nov. 2000");
	puts("  progi <device> [-e|--erase] [-w|--write] [-v|--verify] [-t|--test] [<file>]");

	
	if (argc<2)
	{
		puts("\n Not enough parameters given!");
		exit(EXIT_FAILURE);
	}
	
	// initialisieren
	do_erase=false;
	do_verify=false;
	do_write=false;
	do_test=false;
	do_msg=false;
	
	// Eingabezeile parsen
	
	//  device "/dev/ttyS1"
	device = argv[1];
	if (strstr(device,"/dev/")!=device)	// device muss mit /dev/ beginnen!
	{           	
		puts("\n The device isn't /dev/* !");
		exit(EXIT_FAILURE);
	}
	printf("\n Device : %s\n Actions:",device);
	
	// Optionen registrieren
	for (int i=2;i<argc;i++)
	{
		if (strstr(argv[i],"--erase")==argv[i]) 	do_erase	=true;
		if (strstr(argv[i],"--write")==argv[i]) 	do_write	=true;
		if (strstr(argv[i],"--verify")==argv[i]) 	do_verify	=true;
		if (strstr(argv[i],"--test")==argv[i]) 		do_test		=true;
		
		if (strstr(argv[i],"-e")==argv[i]) 	do_erase	=true;
		if (strstr(argv[i],"-w")==argv[i]) 	do_write	=true;
		if (strstr(argv[i],"-v")==argv[i]) 	do_verify	=true;
		if (strstr(argv[i],"-t")==argv[i]) 	do_test		=true;
	}
	
	if (do_test) 	printf(" test");
	if (do_erase) 	printf(" erase");
   	if (do_write) 	printf(" write");
	if (do_verify) 	printf(" verify");

	// Filename
	if (!do_test && (do_write || do_verify) )
	{
		char *filename;
		filename=argv[argc-1];
		printf("\n File   : %s",filename);
		get_File(filename);
	}

	printf("\n");	
    open_port(device);
	
    if(do_test) perform_test();
    else
    {
		if (do_erase) perform_erase();
     	if (do_write) perform_write();
     	if (do_verify) perform_verify();
    }

    close_port();
	printf("\n");	
	
  return EXIT_SUCCESS;
}

// Schnittstelle ffnen
/***********************************************************************/
void open_port(char *device)
{
	// Ausgabeschnittstelle ffnen
	devicehandle=open(device, O_RDWR | O_FSYNC);

	// Auf Fehler testen
	if (devicehandle<0)
	{	
		puts("\n Error on opening serial device!");
		exit(EXIT_FAILURE);
	}
	
	// alte Konfiguration einlesen
	tcgetattr(devicehandle, &tios);
	tcgetattr(devicehandle, &tios_backup);
	
	// Ausgabeschnittstelle konfigurieren	
	cfmakeraw(&tios);
	cfsetospeed(&tios, B1200);
	cfsetispeed(&tios, B1200);
	
	// Konfiguration anwenden
	tcsetattr(devicehandle, TCSAFLUSH, &tios);
}

// Schnittstelle schlieen
/***********************************************************************/
void close_port()
{
	// Ursprungszustand wiederherstellen
	tcsetattr(devicehandle, TCSAFLUSH, &tios_backup);
	
	// Ausgabeschnittstelle schlieen
	close(devicehandle);
}

// Datei ffnen, lesen und schlieen
/***********************************************************************/
void get_File(char *filename)
{
	int handle;
	handle=open(filename, O_RDONLY);
	if (handle<0)
	{
	 	printf("\n Error on opening file '%s'!\n",filename);
		exit(EXIT_FAILURE);
	}

    filesize=read(handle, buf, 4096);
	if (filesize<1)
	{
	 	printf("\n Error on reading file '%s'!\n",filename);
		exit(EXIT_FAILURE);
	}

	printf("\n  got %i bytes\n",filesize);
	
    close(handle);			
}

// eine Anzahl an us warten
/***********************************************************************/
void delay()
{   	
		// warten auf Ende der Schreiboperation
//	  	fd_set set;
//      FD_ZERO (&set);
//      FD_SET (devicehandle, &set);
//		select(FD_SETSIZE,NULL, &set, NULL, NULL);
		
		// die zuverlssigste Methode: Schnittstelle einfach schlieen und wieder ffnen
		close(devicehandle);
		devicehandle=open(device, O_RDWR | O_FSYNC);
		if (devicehandle<0)
		{	
			puts("\n Error on opening serial device!");
			exit(EXIT_FAILURE);
		}
		tcsetattr(devicehandle, TCSAFLUSH, &tios);
		
		// warten auf Timer
        struct timeval timeout;
        timeout.tv_sec = 1;
        timeout.tv_usec = 0;
        select(1, NULL, NULL, NULL, &timeout);
}


// bertragungstest
/***********************************************************************/
void perform_test()
{
	puts("   transmission test...");
	
	for (int a=1;a<256;a++)			// Ausgabepuffer belegen
	{
		buf[a-1]=(char)a;
	}
	
	write(devicehandle, init_test, 3);	// Initialisierung senden
	write(devicehandle, buf, 255);		// Daten senden
}

// Chip lschen
/***********************************************************************/
void perform_erase()
{
 	puts("   erasing...");
 	
 	write(devicehandle, init_erase, 3);
 	
 	delay();
}

// Chip beschreiben
/***********************************************************************/
void perform_write()
{
 	puts("   writing...");

 	write(devicehandle, init_write, 3);
 	printf("    -> %i Bytes sent\n",write(devicehandle, buf, filesize));

 	delay();
}

// Chip vergleichen
/***********************************************************************/
void perform_verify()
{
 	puts("   verifying...");
 	
 	write(devicehandle, init_verify, 3);
 	printf("    -> %i Bytes sent\n",write(devicehandle, buf, filesize));
}

